/////////////////////////////////////////////////////////////
// FOOD CLASS
//
class Food{
  // GLOBAL VARIABLES
  boolean good, visible; //determine whether food is good (red/blue) and its visibility
  int ftype; //(0,1 = miso,sushi; 2,3,4 = chicken,choco,cheese)
  PVector pos, vel; //PVectors for food position and velocity (no acceleration because conveyor belt is consistent)
  float L, R, T, B; //food collision box boundaries
  // CONSTRUCTOR
  Food(int _ftype){
    ftype = _ftype;
    visible = true; //visibility is true by default
    pos = new PVector(1, 450/2); //default position
    vel = new PVector(globalvel, 0); //default velocity (from globalvel)
    if (ftype >= 2){ //bad foods
      good = false;
    } else { //good foods
      good = true;}
  }
  //
  // FUNCTIONS
  //
  void updateLRTB(){ //update the collision box boundaries based on pos.x and pos.y
    L = pos.x-30;
    R = pos.x+30;
    T = pos.y-30;
    B = pos.y+30;
  }
  //
  void eat(){ //when the food reaches the Fat Man, it will be eaten
    if (good == true){
      game.replaceplate(-13355929); //add a blue plate into the stack
    }
    else if (good == false){
      game.life --; //lose a heart
      game.replaceplate(-57809); //add a red plate into the stack
    }
    game.drawManEat(3*width/4, 3*height/4); //animate Fat Man's mouth
    game.checkgamestate(); //check to see the current status of the game
  }
  //
  void checkclicked(int x, int y, int c){ //check for collision
    if (L < x/2){if (R > x/2){if (T < y/2){if (B > y/2){ //if within box positions
      int[] Colors = {-16711409,-16708344,-13355929,-3670016,-1380865,-9720,-3856,-15400958,-11589888,-8496896,-7145465,-57809,-2056,-1806};
      for (int i = Colors.length-1; i >= 0; i--){ //check if clicked color is the same as a food color
        if (c == Colors[i]){
          visible = false; //set visibility to false if the food is confirmed to be clicked
        }
      }
    }}}}
  }
  //
  void drawFood(float x, float y){ //draw food item depending on ftype
    pushMatrix();
    scale(2); //enlarge food items by 2.0x
    switch(ftype){ //specify and draw the specific food type
      case 0: //miso
        drawMiso(x,y);
        break;
      case 1: //sushi
        drawSushi(x,y);
        break;
      case 2: //chicken
        drawChicken(x,y);
        break;
      case 3: //choco
        drawChococake(x,y);
        break;
      case 4: //cheese
        drawCheesecake(x,y);
        break;
    }
    updateLRTB(); //update collision click boxes
    popMatrix();
  }
  //
  void drawMiso(float x, float y){ //draw Miso Soup
    stroke(#01010F);
    fill(#343467);
    ellipse(x,y, 60,30); //plate
    fill(#EAEDFF);
    triangle(x,y+5, x-25,y-15, x+25,y-15); //bowl body
    rectMode(CENTER);
    rect(x,y+2, 17,8); //bowl base
    fill(#FFDA08);
    ellipse(x,y-15, 50,10); //soup
  }
  //
  void drawSushi(float x, float y){ //draw Sushi
    stroke(#01010F);
    fill(#343467);
    ellipse(x,y, 60,30); //plate
    fill(#FFF0F0);
    ellipse(x,y-5, 40,20); //sushi rice
    fill(#C80000);
    rectMode(CENTER);
    rect(x,y-15, 40,20); //sushi meat
    fill(#010D08);
    rect(x,y-10, 5,30); //sushi seaweed  
  }
  //
  void drawChicken(float x, float y){ //draw Fried Chicken
    stroke(#150002);
    fill(#FF1E2F);
    ellipse(x,y, 60,30); //plate
    fill(#FFF7F8);
    triangle(x,y+5, x-25,y-15, x+25,y-15); //bowl body
    rectMode(CENTER);
    rect(x,y+2, 17,8); //bowl base
    ellipse(x,y-15, 50,10); //bowl top
    fill(#7E5900);
    rect(x+10,y-17, 10,10); //fried chicken
    rect(x-13,y-20, 13,10); //fried chicken
    rect(x-2,y-23, 19,13); //fried chicken
  }
  //
  void drawChococake(float x, float y){ //draw Chocolate Cake
    stroke(#150002);
    fill(#FF1E2F);
    ellipse(x,y, 60,30); //plate
    fill(#4F2700);
    rectMode(CENTER);
    rect(x,y-5, 40,20); //cake base
    rect(x,y-20, 40,15); //cake top
    fill(#FFF8F2);
    rect(x,y-5, 40,2); //cake cream
  }
  //
  void drawCheesecake(float x, float y){ //draw Green Tea Cheesecake
    stroke(#150002);
    fill(#FF1E2F);
    ellipse(x,y, 60,30); //plate
    fill(#92F807);
    rectMode(CENTER);
    rect(x,y-5, 40,20); //cake base
    triangle(x-20,y-15, x+20,y-3, x+20,y-20); //cake top
  }
  //
}
