import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class fat_main extends PApplet {

////////////////////////////////////////////////////////////
// DECLARATIONS
//
PImage bg, img, yw, go, title; //imported image files
ArrayList Foods; //ArrayList of class object "Food"
float globalvel = 10; //Global velocity for food moving speed and chair-breaking/Man-falling speed
float globalacc = globalvel/100; //Global acceleration for chair-breaking/Man-falling speed
float n = 0; //beginning rotation angle and chair-breaking/Man-falling position addition
GS game; //the main game state
//
public void setup() {
  // BACKGROUND SETUP
  size(800,500);
  title = loadImage("title.bmp");
  bg = loadImage("bg.bmp");
  yw = loadImage("youwin.bmp");
  go = loadImage("gameover.bmp");
  img = loadImage("heart.png");
  // INITIALIZATION
  game = new GS(); //create a new game object
  Foods = new ArrayList(); //create an empty Food ArrayList
}
//
public void draw(){
  // CALL FUNCTIONALITY
  switch(game.state){ //determine the game state/screen
    case 0: //title screen
      background(title);
      break;
    case 1: //main gameplay screen
      background(bg);
      game.run(); //run the main game with each draw interval
      break;
    case 2: //chair breaking process
      background(bg);
      globalvel += globalacc; //addition of velocity based on acceleration
      n += globalvel; //addition of position based on velocity
      game.chairBreaks(n); //drawing chair-breaking/Man-falling process
      break;
    case 3: //game over screen
      background(go);
      break;
    case 4: //you win screen
      background(yw);
      break;
  }
}
//
public void mousePressed(){
  switch(game.state){ //determine mousePressed effects based on game state
    case 0: //title screen
      game.state = 1; //clicking the title screen takes you to the main gameplay
      break;
    case 1: //main gameplay screen
      //on click, determine if a food object is clicked
      int c = get(mouseX,mouseY); //first record the pixel color of the mouse click
      for (int i = Foods.size()-1; i >= 0; i--){ //look into ArrayList of Foods
        Food food = (Food) Foods.get(i);
        food.checkclicked(mouseX,mouseY,c); //check if the specific food is clicked
        if (food.visible == false){ //if a food is clicked, its visibility will be false
          Foods.remove(i); //remove the food from the ArrayList if clicked
          break;
        }
      }
      break;
  }
}
//
public int randomF(int dif){ //randomize a food item based on the "difficulty" (see declarations under classGS)
  int rnd = PApplet.parseInt(random(5));
  for (int i = dif-1; i >= 0; i--){
    if (rnd < 2){
      rnd = PApplet.parseInt(random(5));
    }
  }
  return rnd;
}


/////////////////////////////////////////////////////////////
// FOOD CLASS
//
class Food{
  // GLOBAL VARIABLES
  boolean good, visible; //determine whether food is good (red/blue) and its visibility
  int ftype; //(0,1 = miso,sushi; 2,3,4 = chicken,choco,cheese)
  PVector pos, vel; //PVectors for food position and velocity (no acceleration because conveyor belt is consistent)
  float L, R, T, B; //food collision box boundaries
  // CONSTRUCTOR
  Food(int _ftype){
    ftype = _ftype;
    visible = true; //visibility is true by default
    pos = new PVector(1, 450/2); //default position
    vel = new PVector(globalvel, 0); //default velocity (from globalvel)
    if (ftype >= 2){ //bad foods
      good = false;
    } else { //good foods
      good = true;}
  }
  //
  // FUNCTIONS
  //
  public void updateLRTB(){ //update the collision box boundaries based on pos.x and pos.y
    L = pos.x-30;
    R = pos.x+30;
    T = pos.y-30;
    B = pos.y+30;
  }
  //
  public void eat(){ //when the food reaches the Fat Man, it will be eaten
    if (good == true){
      game.replaceplate(-13355929); //add a blue plate into the stack
    }
    else if (good == false){
      game.life --; //lose a heart
      game.replaceplate(-57809); //add a red plate into the stack
    }
    game.drawManEat(3*width/4, 3*height/4); //animate Fat Man's mouth
    game.checkgamestate(); //check to see the current status of the game
  }
  //
  public void checkclicked(int x, int y, int c){ //check for collision
    if (L < x/2){if (R > x/2){if (T < y/2){if (B > y/2){ //if within box positions
      int[] Colors = {-16711409,-16708344,-13355929,-3670016,-1380865,-9720,-3856,-15400958,-11589888,-8496896,-7145465,-57809,-2056,-1806};
      for (int i = Colors.length-1; i >= 0; i--){ //check if clicked color is the same as a food color
        if (c == Colors[i]){
          visible = false; //set visibility to false if the food is confirmed to be clicked
        }
      }
    }}}}
  }
  //
  public void drawFood(float x, float y){ //draw food item depending on ftype
    pushMatrix();
    scale(2); //enlarge food items by 2.0x
    switch(ftype){ //specify and draw the specific food type
      case 0: //miso
        drawMiso(x,y);
        break;
      case 1: //sushi
        drawSushi(x,y);
        break;
      case 2: //chicken
        drawChicken(x,y);
        break;
      case 3: //choco
        drawChococake(x,y);
        break;
      case 4: //cheese
        drawCheesecake(x,y);
        break;
    }
    updateLRTB(); //update collision click boxes
    popMatrix();
  }
  //
  public void drawMiso(float x, float y){ //draw Miso Soup
    stroke(0xff01010F);
    fill(0xff343467);
    ellipse(x,y, 60,30); //plate
    fill(0xffEAEDFF);
    triangle(x,y+5, x-25,y-15, x+25,y-15); //bowl body
    rectMode(CENTER);
    rect(x,y+2, 17,8); //bowl base
    fill(0xffFFDA08);
    ellipse(x,y-15, 50,10); //soup
  }
  //
  public void drawSushi(float x, float y){ //draw Sushi
    stroke(0xff01010F);
    fill(0xff343467);
    ellipse(x,y, 60,30); //plate
    fill(0xffFFF0F0);
    ellipse(x,y-5, 40,20); //sushi rice
    fill(0xffC80000);
    rectMode(CENTER);
    rect(x,y-15, 40,20); //sushi meat
    fill(0xff010D08);
    rect(x,y-10, 5,30); //sushi seaweed  
  }
  //
  public void drawChicken(float x, float y){ //draw Fried Chicken
    stroke(0xff150002);
    fill(0xffFF1E2F);
    ellipse(x,y, 60,30); //plate
    fill(0xffFFF7F8);
    triangle(x,y+5, x-25,y-15, x+25,y-15); //bowl body
    rectMode(CENTER);
    rect(x,y+2, 17,8); //bowl base
    ellipse(x,y-15, 50,10); //bowl top
    fill(0xff7E5900);
    rect(x+10,y-17, 10,10); //fried chicken
    rect(x-13,y-20, 13,10); //fried chicken
    rect(x-2,y-23, 19,13); //fried chicken
  }
  //
  public void drawChococake(float x, float y){ //draw Chocolate Cake
    stroke(0xff150002);
    fill(0xffFF1E2F);
    ellipse(x,y, 60,30); //plate
    fill(0xff4F2700);
    rectMode(CENTER);
    rect(x,y-5, 40,20); //cake base
    rect(x,y-20, 40,15); //cake top
    fill(0xffFFF8F2);
    rect(x,y-5, 40,2); //cake cream
  }
  //
  public void drawCheesecake(float x, float y){ //draw Green Tea Cheesecake
    stroke(0xff150002);
    fill(0xffFF1E2F);
    ellipse(x,y, 60,30); //plate
    fill(0xff92F807);
    rectMode(CENTER);
    rect(x,y-5, 40,20); //cake base
    triangle(x-20,y-15, x+20,y-3, x+20,y-20); //cake top
  }
  //
}
/////////////////////////////////////////////////////////////
// GAME STATE CLASS
//
class GS{
  // GLOBAL VARIABLES
  int difficulty = 0; //set how common blue plates are generated, with 0 being easiest/most common
  int life = 5; //set the number of hearts, with 1 being minimum
  int state = 0; //set game state, 0=title, 1=play, 2=dying, 3=lost, 4=won
  int[] fatstack = new int[20]; //set number of plates of food in order to win game
  // CONSTRUCTOR
  GS(){
  }
  //
  // FUNCTIONS
  //
  public void run(){ //main function of the gameplay
    drawChair(width/4, 3*height/4+50); //draw Your chair
    drawChair(3*width/4, 3*height/4+50); //draw Fat Man's chair
    drawMan(3*width/4, 3*height/4); //draw Fat Man
    drawYou(width/4, 3*height/4+50); //draw You
    drawTable(); //draw Table
    checkfstate(); //check the state of the foods
    drawlife(); //draw the hearts on the screen
    drawstack(); //draw the stacked plates
  }
  //
  public void chairBreaks(float n){ //when game.state = 2, the chair breaks down and Fat Man falls down
    drawChair(width/4, 3*height/4+50); //normally draw Your chair
    int x = 3*width/4;
    int y = 3*height/4+50;
    rectMode(CENTER);
    if (n < 90){ //this is to control the angle of the chair rotating
      fill(0xff552F1D);
      pushMatrix();
      translate(x-130,y-50);
      rotate(radians(-n));
      rect(0,0, 20,500); //draw chair
      popMatrix();
      pushMatrix();
      translate(x+130,y-50);
      rotate(radians(n));
      rect(0,0, 20,500); //draw chair
      popMatrix();
    }
    else{ //when the chair is rotated through 90 degrees, end the animation
      state = 3; //takes player to game over screen
    }
    fill(0xffB2273C);
    rect(x,y-200+2*n, 260,140); //draw chair
    drawMan(3*width/4, (3*height/4)+3*n); //draw Fat Man, but with a changing position and velocity
    drawManEat(3*width/4, (3*height/4)+3*n); //draw Fat Man's open mouth, but also moving with the body
    drawYou(width/4, 3*height/4+50); //draw You normally
    drawTable(); //draw Table normally
  }
  //
  public void drawlife(){ //draw hearts on screen based on the life number
    for (int i = life-1; i >= 0; i--){
      image(img, width-50*(i+1), 0); //"-50" is to ensure they are evenly spaced out
    }
  }
  //
  public void drawstack(){ //draw the stack of plates extracted from the int[] List
    int t = 20; //default plate position
    for (int i = fatstack.length-1; i >= 0; i--){
      if (fatstack[i] != 0){ //if the plate color isn't already filled
        fill(fatstack[i]); //plate color depending on the fatstack value
        pushMatrix();
        scale(2);
        ellipse((width-75)/2,((height-100)/2)-100+(t*5), 60,30); //plate
        t --; //subtract as each plate is stacked
        popMatrix();
      }
    }
  }
  //
  public void replaceplate(int c){ //color the black plates to either blue or red
    for (int i = fatstack.length-1; i >= 0; i--){
      if (fatstack[i] == 0){ //if plate is black
        fatstack[i] = c; //color it with the parameter c
        break;
      }
    }    
  }
  //
  public void checkgamestate(){ //check to see if the game is winning or losing
    if (life == 0){ //no more hearts
      game.state = 2; //switch to chair-breaking screen
    }
    if (fatstack[0] != 0){ //if stack of plates reaches max
      game.state = 4; //switch to winning screen
    }
  }
  //
  public void checkfstate(){ //check the state of foods and move their positions
    if (Foods.size() <= 5){ //if there are less than 5 food in the ArrayList
      Food newfood = new Food(randomF(game.difficulty));
      if (Foods.size() != 0){
        Food lastfood = (Food) Foods.get(Foods.size()-1); //retrieve the last food in the ArrayList
        newfood.pos.x = lastfood.pos.x-30*3; //set the initial position of the new food, based off the last in the ArrayList
      }
      Foods.add(newfood); //add the new food into the ArrayList
    }
    for (int i = Foods.size()-1; i >= 0; i--){ //go through every Food in ArrayList
      Food food = (Food) Foods.get(i);
        food.vel.x = globalvel/2; //set velocity based on globalvel (/2 because it's scaled 2.0)
        food.pos.x += food.vel.x; //set position based on velocity
        food.drawFood(food.pos.x,food.pos.y); //draw food based on defined position
        if (food.pos.x > 3*width/8){ //if food position is past the Fat Man's eat line
          Foods.remove(i); //remove it
          food.eat(); //have Fat Man eat it
          break;
        }
    }
  }
  //
  public void drawMan(int x, float y){
    fill(255);
    ellipse(x,y, 400,400); //body
    arc(x-100,y-100, 100,70, radians(70),radians(200)); //(his) right moob
    pushMatrix();
    translate(x+100,y-100);
    rotate(radians(180));
    arc(0,0, 100,70, radians(160),radians(300)); //(his) left moob
    popMatrix();
    fill(0xffF7EBC3);
    ellipse(x,y-200, 100,100); //chest
    ellipse(x,y-280, 200,200); //head
    pushMatrix();
    translate(x,y-260);
    rotate(radians(315));
    arc(0,0, 80,80, radians(70),radians(200)); //mouth
    popMatrix();
    arc(x+50,y-250, 50,50, radians(90),radians(180)); //(his) left cheek
    pushMatrix();
    translate(x-50,y-250);
    rotate(radians(270));
    arc(0,0, 50,50, radians(90),radians(180)); //(his) right cheek
    popMatrix();
    pushMatrix();
    translate(x,y-210);
    rotate(radians(315));
    arc(0,0, 40,40, radians(70),radians(200)); //chin
    popMatrix();
    fill(0);
    ellipse(x-48,y-300, 15,30);
    ellipse(x+48,y-300, 15,30); //eyes
  }
  //
  public void drawManEat(int x, float y){
    fill(0xffF7EBC3);
    ellipse(x,y-280, 200,200); //head
    fill(255,0,0);
    ellipse(x,y-225, 80,30); //opened mouth
    fill(0xffF7EBC3);
    arc(x+50,y-250, 50,50, radians(90),radians(180)); //(his) left cheek
    pushMatrix();
    translate(x-50,y-250);
    rotate(radians(270));
    arc(0,0, 50,50, radians(90),radians(180)); //(his) right cheek
    popMatrix();
    pushMatrix();
    translate(x,y-205);
    rotate(radians(315));
    arc(0,0, 40,40, radians(70),radians(200)); //chin
    popMatrix();
        fill(0);
    ellipse(x-48,y-300, 15,30);
    ellipse(x+48,y-300, 15,30); //eyes
  }
  //
  public void drawYou(int x, int y){
    fill(0xff6950AF);
    ellipse(x,y, 200, 400); //body
    fill(0xffF0DDA0);
    ellipse(x,y-200, 70,70); //chest
    ellipse(x,y-280, 200,200); //head
    pushMatrix();
    translate(x,y-260);
    rotate(radians(315));
    arc(0,0, 80,80, radians(70),radians(200)); //mouth
    popMatrix();
    fill(0);
    ellipse(x-48,y-300, 15,30);
    ellipse(x+48,y-300, 15,30); //eyes
  }
  //
  public void drawChair(int x, int y){
    fill(0xff552F1D);
    rectMode(CENTER);
    rect(x-130,y-50, 20,500);
    rect(x+130,y-50, 20,500);
    fill(0xffB2273C);
    rect(x,y-200, 260,140);
  }
  //
  public void drawTable(){
    fill(0xff552F1D);
    rectMode(CENTER);
    rect(width/2,4*height/5+50, width+1,200); //table
    fill(0xff505050);
    rect(width/2,480, width+1,100); //conveyor belt
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0FF", "fat_main" });
  }
}
