////////////////////////////////////////////////////////////
// DECLARATIONS
//
PImage bg, img, yw, go, title; //imported image files
ArrayList Foods; //ArrayList of class object "Food"
float globalvel = 10; //Global velocity for food moving speed and chair-breaking/Man-falling speed
float globalacc = globalvel/100; //Global acceleration for chair-breaking/Man-falling speed
float n = 0; //beginning rotation angle and chair-breaking/Man-falling position addition
GS game; //the main game state
//
void setup() {
  // BACKGROUND SETUP
  size(800,500);
  title = loadImage("title.bmp");
  bg = loadImage("bg.bmp");
  yw = loadImage("youwin.bmp");
  go = loadImage("gameover.bmp");
  img = loadImage("heart.png");
  // INITIALIZATION
  game = new GS(); //create a new game object
  Foods = new ArrayList(); //create an empty Food ArrayList
}
//
void draw(){
  // CALL FUNCTIONALITY
  switch(game.state){ //determine the game state/screen
    case 0: //title screen
      background(title);
      break;
    case 1: //main gameplay screen
      background(bg);
      game.run(); //run the main game with each draw interval
      break;
    case 2: //chair breaking process
      background(bg);
      globalvel += globalacc; //addition of velocity based on acceleration
      n += globalvel; //addition of position based on velocity
      game.chairBreaks(n); //drawing chair-breaking/Man-falling process
      break;
    case 3: //game over screen
      background(go);
      break;
    case 4: //you win screen
      background(yw);
      break;
  }
}
//
void mousePressed(){
  switch(game.state){ //determine mousePressed effects based on game state
    case 0: //title screen
      game.state = 1; //clicking the title screen takes you to the main gameplay
      break;
    case 1: //main gameplay screen
      //on click, determine if a food object is clicked
      color c = get(mouseX,mouseY); //first record the pixel color of the mouse click
      for (int i = Foods.size()-1; i >= 0; i--){ //look into ArrayList of Foods
        Food food = (Food) Foods.get(i);
        food.checkclicked(mouseX,mouseY,c); //check if the specific food is clicked
        if (food.visible == false){ //if a food is clicked, its visibility will be false
          Foods.remove(i); //remove the food from the ArrayList if clicked
          break;
        }
      }
      break;
  }
}
//
int randomF(int dif){ //randomize a food item based on the "difficulty" (see declarations under classGS)
  int rnd = int(random(5));
  for (int i = dif-1; i >= 0; i--){
    if (rnd < 2){
      rnd = int(random(5));
    }
  }
  return rnd;
}


